@ECHO OFF
CLS
:Intro
REM Quick System Checker 2018-2019 TechKit Limited
REM Please feel free to redistribute this... although I'd like my name and details to stay in it please.
REM http://www.techkit.co.uk
REM Originally created by Alasdair Clark
REM Version 2.0 Updates, options and logging
SETLOCAL
SET VER=2.0.0a
SET "TITLE=Quick System Checker (c)2018-2019 TechKit Limited"
TITLE %TITLE%.   Version %VER%
ECHO %TITLE% 
ECHO.
ECHO This will do an 'online' (system running) scan of the system image and attempt repair

CALL :AdminCheck
CALL :init
GOTO options

:Options
SET stage=options

    CALL :Spaces
    ECHO Quick System Checker (c)2018-2019 TechKit Limited 
    ECHO -------------------------------------------------
    ECHO.
    ECHO Please choose from the following options:
    ECHO.
    ECHO  A - Press A to run a fairly thorough, automated but basic scan
    ECHO  C - Press C check the filesystem
    ECHO  V - Press V to open Windows Defender
    ECHO  D - Press D to run DISM
    ECHO  S - Press S to run SFC
    ECHO  P - Press P to exit to a command prompt
    ECHO  H - Press H for more help
    ECHO  X - Press X to Exit
    REM ECHO  1 - Press 1 to debug, edited as appropriate
    ECHO.
    ECHO It is highly recommended run a automated scan This fixes most problems. 
    ECHO After the operations are completed you will be returned to this menu.
    ECHO. 
    IF %debug%==1 ECHO DEBUG MODE ENABLED - Press 1 to exit debug mode

CHOICE /C:ACVDSPHX1 /N /M "Press a key"

    REM Errorlevel 9 is for debug
    IF ERRORLEVEL 9 (
        CALL :debug
        GOTO options
        )
    IF ERRORLEVEL 8 (
        CALL :quit
        GOTO options
        )
    IF ERRORLEVEL 7 (
        CALL :Help 
        GOTO options
        )
    IF ERRORLEVEL 6 (
        CALL :cmd
        GOTO options
        )
    IF ERRORLEVEL 5 (
        CALL :SFCoptions
        GOTO options
        )
    IF ERRORLEVEL 4 (
        CALL :DISMoptions
        GOTO options
        )
    IF ERRORLEVEL 3 (
        CALL :Defender
        GOTO options
        )
     IF ERRORLEVEL 2 (
        CALL :ChkDsk
        GOTO options
        )
    IF ERRORLEVEL 1 (
        CALL :Auto
        GOTO options
        )
GOTO :eof

:AdminCheck
REM Using net service to check for administrator privileges
NET SESSION >nul 2>&1
IF %ERRORLEVEL% EQU 0 (
    SET stage=options
    GOTO :eof
) ELSE (
    ECHO This command needs to be run with administrator privileges, right click on the icon and click "Run as Administrator"
    PAUSE
    GOTO quit
)
GOTO :eof

:Init
REM Set the screen size
    MODE CON COLS=132 LINES=40
REM (Re)SET all (ok most) strings
    SET "tempfile=%tmp%\TechKit_Scan.TMP"
    SET "file=%userprofile%\Desktop\TechKit Repair Log.txt"
    SET "startdate=%date%"
    SET "starttime=%time%"
    SET "cstartdate=Not set"
    SET "cstarttime=Not set"
    SET "sstring="
    SET "command=NONE"
    SET "chkdskoptions="
    SET "debug=0"
    SET "chkdskerrorlevel=0"
    set "lastoccur="
    SET "autoscan=0"
GOTO :eof

:Auto
REM Call all scans 
CALL :Spaces
ECHO This will now run five seperate scans. Depending on what is found
ECHO it can take from a few hours to significantly longer to complete.
ECHO There is no user input needed on these scans unless there are errors.
ECHO If errors are found then repeat the scan, sometimes it can only fix
ECHO one problem at a time.
SET "autoscan=1"
REM Call a disk check
    CALL :Spaces
    CALL :ChkDsk
REM Call DISM check health
    CALL :Spaces
    CALL :DISM_CheckHealth
REM Call DISM Scan helth
    CALL :Spaces
    CALL :DISM_ScanHealth
REM Call DISM Restore Health 
    CALL :Spaces
    CALL :DISM_RestoreHealth
REM Call SFC scan now
    CALL :Spaces
    CALL :SFC_scannow
SET "autoscan=0"
GOTO :eof

:ChkDsk
REM Use chkdsk to scan the system drive
ECHO Great, let's do an initial scan on the System Drive to see what's happening.
ECHO The initial scan should take less than half an hour, any further scans can take much longer.
ECHO.
SET "command=C:\^>chkdsk %chkdskoptions% %SystemDrive%"
CALL :EchoCommand
POWERSHELL "chkdsk %chkdskoptions% %SystemDrive% | Tee-Object -filepath %tempfile%UTF8BOM.TMP"; "EXIT $lastexitcode"
    SET "chkdskerrorlevel=%ERRORLEVEL%"
    SET "sstring=Progress:"
    CALL :WriteLog
    cmd /k exit /b %chkdskerrorlevel%
    IF %chkdskerrorlevel%==3 (
        ECHO Could not check the disk, errors could not be fixed, or errors were not fixed because /f was not specified on %SystemDrive%.
        ECHO It is highly recommended that the computer is restarted now to check the drive for errors
        ECHO.
        CALL :ChkDskEROC
        )
    IF %chkdskerrorlevel%==2 (
        ECHO Performed disk cleanup ^(such as garbage collection^)... did not perform cleanup because /f was not specified on %SystemDrive%.
        ECHO It is recommended that the computer is restarted now to check the drive for errors
        ECHO.
        CALL :ChkDskEROC
        )
    IF %chkdskerrorlevel%==1 (
        ECHO Errors were found and fixed on %SystemDrive%.
        )
    IF %chkdskerrorlevel%==0 (
        ECHO No errors were found on %SystemDrive%.
        )
GOTO :eof

:ChkDskEROC
CALL :spaces
ECHO  X Press X to exit 
ECHO  R Press R to restart the computer and check the drive ***YOU MUST SAVE AND CLOSE ANY OPEN PROGRAMS FIRST***
ECHO  O Press O to manually input CHKDSK options
IF %autoscan%==1 ECHO  C Press C to force the checks to continue (THIS IS NOT RECOMMENDED WITH HDD ERRORS)
CHOICE /C:CORX /N  /M "Press a key"
IF ERRORLEVEL 4 GOTO :quit
IF ERRORLEVEL 3 (
    CALL :spaces >> "%file%"
    ECHO Reset any blocks on ChkNTFS >> "%file%"
    chkntfs /D >> "%file%"
    ECHO Setting a flag to make the system drive check itself at boot >> "%file%"
    fsutil dirty set %SystemDrive% >> "%file%"
    chkntfs /C %SystemDrive% >> "%file%"
    shutdown /g /t 40 /d p:2:2 /c "Restart to chkdsk %SystemDrive%" >> "%file%"
    GOTO :quit
    )
IF ERRORLEVEL 2 (
    ECHO.
    ECHO Read the above output and if errors are found chkdsk should tell you what operators to add.
    SET /P chkdskoptions="Please enter any options for chkdsk, e.g. /F /scan /spotfix etc. "
    ECHO You have entered:
    SET chkdskoptions
    ECHO Now to run chkdsk again, with these options. Follow any instruction given by chkdsk
    GOTO :chkdsk
    GOTO :eof
    )
IF ERRORLEVEL 1 (
    GOTO :eof
    )
GOTO :eof

:Defender
REM Check for Viruses with Windows Defender.
ECHO THIS IS NOT YET IMPLEMENTED
    ECHO Windows Defender system scan interface
    ECHO --------------------------------------
    ECHO.
    ECHO Please choose from the following options:
    ECHO.
    ECHO  U  Update Windows Defender from the Microsoft Update Server. (Overrides custom settings)
    ECHO  1  Quick scan (expected 5-10 minutes)
    ECHO  2  Full system scan (expected 4 hours to over a day, depending on computer)
    ECHO  3  File and directory custom scan NOT WORKING
	ECHO  4  OFFLINE Scan. This command starts a Windows Defender offline scan on the computer
    ECHO     YOU MUST SAVE AND CLOSE ALL PROGRAMS BEFORE RUNNING THE OFFLINE SCAN (Restart required)
	ECHO  R  Results from full scan
REM slightly odd order to make the code after nicer, whilst keeping the 'standard' numbers for defender
    CHOICE /C:1234RU /N /M "Press a key"
::    POWERSHELL -command "\"%ProgramFiles%\Windows Defender\mpcmdrun.exe -scan -%errorlevel%\"" " | Tee-Object -filepath %tempfile%UTF8BOM.TMP"; "EXIT $lastexitcode"
    If %ERRORLEVEL%==1 (
        SET "command=PS C:\^>Start-MpScan -ScanType QuickScan"
        ECHO Quick Scan: Note this will appear to hang when it nearly reaches the end. This is normal, it takes a while. 
        CALL :EchoCommand
        POWERSHELL "Start-MpScan -ScanType QuickScan"; "EXIT $lastexitcode"
        GOTO DefenderRes
    )
    If %ERRORLEVEL%==2 (
        SET "command=PS C:\^>Start-MpScan -ScanType FullScan"
        CALL :EchoCommand
        ECHO Full Scan: Note this will appear to hang when it nearly reaches the end. This is normal. This scan is slow.
        ECHO Because this scan is so slow it is suggested you run it as a background service. 
        CHOICE /C:FS /N /M "Press S to run it as a service in the background, or F for foreground.
            IF ERRORLEVEL 1 POWERSHELL "$DefFull = Start-MpScan -ScanType FullScan -AsJob"; "EXIT $lastexitcode"
			IF ERRORLEVEL 0 POWERSHELL "Start-MpScan -ScanType FullScan"; "EXIT $lastexitcode"
        GOTO DefenderRes
    ) 
    If %ERRORLEVEL%==3 (
        SET "command=PS C:\^> NOT IMPLEMENTED "
        CALL :EchoCommand
        ECHO NOT IMPLEMENTED
        GOTO DefenderRes
    )
    If %ERRORLEVEL%==4 (
        SET "command=PS C:\^>Start-MpWDOScan"
		CALL :EchoCommand
        ECHO Full Scan: Note this will appear to hang when it nearly reaches the end. This is normal. This scan is slow. 
        POWERSHELL "Start-MpWDOScan"; "EXIT $lastexitcode"
        GOTO DefenderRes
    )
    If %ERRORLEVEL%==5 (
        SET "command=PS C:\^>Receive-Job -Job $DefFull"; "EXIT $lastexitcode"
		CALL :EchoCommand
        ECHO This might only flash briefly when the scan is running, to continue you might need to press CTRL+C
        POWERSHELL "Receive-Job -Job $DefFull"
            REM Add cancel options here.
        GOTO DefenderRes
    )
    If %ERRORLEVEL%==6 (
        SET "command=PS C:\^>Update-MpSignature -UpdateSource MicrosoftUpdateServer"
		CALL :EchoCommand
        ECHO Update Windows Defender from the Microsoft Update Server
        POWERSHELL "Update-MpSignature -UpdateSource MicrosoftUpdateServer"; "EXIT $lastexitcode"
        GOTO DefenderRes
    )

:DefenderRes
    ECHO Returned %errorlevel%
    SET "sstring=INCLUDE-EVERYTHING"
	REM Get the stats
    POWERSHELL "Get-MpComputerStatus | Tee-Object -filepath %tempfile%UTF8BOM.TMP"
    CALL :WriteLog    
GOTO :eof

:DISM_CheckHealth
    ECHO Find out if any corruption is already logged (Online check)
    ECHO -----------------------------------------------------------
    ECHO This stage should take a few minutes at most
    SET "command=C:\^>DISM /Online /Cleanup-Image /CheckHealth"
    CALL :EchoCommand
    POWERSHELL "DISM /Online /Cleanup-Image /CheckHealth | Tee-Object -filepath %tempfile%UTF8BOM.TMP"; "EXIT $lastexitcode"
    REM The square bracket has to be in square brackets to prove it isn't a square bracket.
    SET sstring=[[]
    CALL :WriteLog
GOTO :eof

:DISM_ScanHealth
    ECHO Scan the system image for corruption and log it (Online scan)
    ECHO -------------------------------------------------------------
    ECHO This will take some time (more than an hour) - please wait.
    SET "command=C:\^>DISM /Online /Cleanup-Image /ScanHealth"
    CALL :EchoCommand
    POWERSHELL "DISM /Online /Cleanup-Image /ScanHealth | Tee-Object -filepath %tempfile%UTF8BOM.TMP"; "EXIT $lastexitcode"
    SET sstring=[[]
    CALL :WriteLog
GOTO :eof

:DISM_RestoreHealth
    ECHO Repair any logged corruption from above (Online repair)
    ECHO -------------------------------------------------------
    ECHO This will take some time (more than an hour) - please wait.
    SET "command=C:\^>DISM /Online /Cleanup-Image /RestoreHealth"
    CALL :EchoCommand
    POWERSHELL "DISM /Online /Cleanup-Image /RestoreHealth | Tee-Object -filepath %tempfile%UTF8BOM.TMP"; "EXIT $lastexitcode"
    SET sstring=[[]
    CALL :WriteLog
GOTO :eof

:SFC_scannow
    ECHO Scan and repair system files
    ECHO ----------------------------
    ECHO This will take some time - please wait.
    SET "command=C:\^>SFC /ScanNow"
    CALL :EchoCommand
    REM Bodgy powershell hack because SFC doesn't play nicely
    POWERSHELL "$prev = [console]::OutputEncoding"; "[console]::OutputEncoding = [Text.Encoding]::Unicode"; "SFC /scannow | Tee-Object -filepath %tempfile%"; "[console]::OutputEncoding = $prev"; "EXIT $lastexitcode"
    POWERSHELL "$utf16tmp = Get-Content "%tempfile%" -raw"; "Out-File -FilePath %tempfile%UTF8BOM.TMP -InputObject $utf16tmp"
    SET sstring=Verification
    CALL :WriteLog
GOTO :eof

:DISMoptions
ECHO DISM
ECHO This part of the code is not yet written
GOTO :eof

:SFCoptions
ECHO SFC 
ECHO This part of the code is not yet written
GOTO :eof

:cmd
CALL :cleanup
CALL :Spaces
ECHO Type EXIT to quit the command prompt and continue scanning the computer
CMD
CALL :Spaces
GOTO :intro

:quit
CALL :cleanup
EXIT
GOTO :eof

:cleanup
ENDLOCAL
IF EXIST %tempfile%UTF8BOM.TMP DEL %tempfile%UTF8BOM.TMP
IF EXIST %tempfile%UTF16.TMP DEL %tempfile%UTF16.TMP
IF EXIST %tempfile% DEL %tempfile%
GOTO :eof

:EchoCommand
    ECHO %command%
    SET cstartdate=%date%
    SET cstarttime=%time%
GOTO :eof

:WriteLog
REM Add a few lines to make the log more readable
    ECHO -o-o-o-o-o-o-o-o-o-o-o-o Windows Health Checker %ver% o-o-o-o-o-o-o-o-o-o-o-o- >> "%file%"
    IF %debug%==1 ECHO Debug flag set >> "%file%"
    IF %autoscan%==1 ECHO Running Automated scan >> "%file%"
    ECHO. >> "%file%"
    ECHO. >> "%file%"
    ECHO Start time was %startdate% at %starttime% >> "%file%"
    ECHO Command start time was %cstartdate% at %cstarttime% >> "%file%"
    ECHO Command called was: %command% >> "%file%"
    ECHO. >> "%file%"
    REM Convert the file to UTF-8
        CALL :unBOM
        REM Stage 1, remove the unwanted content
        findstr /R /V "^%sstring%" "%tempfile%" > "%tempfile%spaces.tmp"
        REM Stage 2, remove the blank lines
        findstr /R /C:"[^ 	]" "%tempfile%spaces.tmp" >> "%file%"
        REM Put the last removed line back in
        IF %debug% EQU 1 CALL :LastOccur >> "%file%"
    DEL %tempfile%spaces.tmp
    ECHO. >> "%file%"
    ECHO Finish time is %date% at %time% >> "%file%"
CALL :Spaces >> "%file%"
GOTO :eof

:unBOM
REM Convert the log file to UTF-8 from UCS-2 LE BOM
POWERSHELL "$utf8bomtmp = Get-Content "%tempfile%UTF8BOM.TMP" -raw"; "Out-File -FilePath %tempfile% -InputObject $utf8bomtmp -Encoding ASCII"
GOTO :eof

:LastOccur
IF %debug%==1 (
    ECHO OFF
    ECHO Echo is off for :LastOccur as otherwise it fills up the logfile > CON
    )
setlocal
    for /F "delims=" %%G in ('
        findstr /C:"%sstring%" "%tempfile%"
        ') do set "lastoccur=%%G"
    echo %lastoccur%
    echo lastoccur returned: %lastoccur% > CON
        SET "lastoccur="
endlocal
IF %debug%==1 ECHO ON
GOTO :eof

:Spaces
REM This is simply to add some space on screen without puting it into code every time
IF %debug%==1 (
    ECHO OFF
    ECHO Echo is off for :LastOccur as otherwise it fills up the logfile > CON
    )
ECHO.
ECHO.
ECHO.
IF %debug%==1 ECHO ON
GOTO :eof

:debug
ECHO Enable or disable debug mode
IF %debug%==1 (
    SET "debug=0"
    ECHO OFF
    ) ELSE (
    SET "debug=1"
    ECHO ON
    REM Call any routine to debug
    CALL :debugroutine
    )
GOTO :eof

:debugroutine
REM Set any required variables to test
REM To debug a routine enter it below
GOTO :eof

:Help
REM This is to give more information on the options menu
echo Copied from https://support.microsoft.com/en-gb/help/929833/use-the-system-file-checker-tool-to-repair-missing-or-corrupted-system
echo.
echo Use the System File Checker tool to repair missing or corrupted system files
echo.
echo Applies to: Windows 8.1, Windows 8.1 Enterprise, Windows 8.1 Pro, Windows 8, Windows 8 Enterprise, Windows 8 Pro, Windows 7 Enterprise, Windows 7 Home Basic, Windows 7 Home Premium, Windows 7 Professional, Windows 7 Starter, Windows 7 Ultimate, Windows Vista Enterprise 64-bit Edition, Windows Vista Ultimate 64-bit Edition, Windows Vista Business, Windows Vista Business 64-bit Edition, Windows Vista Enterprise, Windows Vista Ultimate, Windows 10
echo.
echo If some Windows functions aren't working or Windows crashes, use the System File Checker to scan Windows and restore your files.? 
echo. 
echo Though the steps below might look complicated at first glance, just follow them in order, step-by-step, and well try to get you back on track.
echo.
echo.
echo Run the System File Checker tool (SFC.exe)
echo To do this, follow these steps:
echo.
echo     Open an elevated command prompt. To do this, do the following as your appropriate:
echo     Show All
echo     Windows 8.1 or Windows 8
echo     Windows 10, Windows 7, or Windows Vista
echo.
echo     If you are running Windows 10, Windows 8.1 or Windows 8, first run the inbox Deployment Image Servicing and Management (DISM) tool prior to running the System File Checker.  (If you are running Windows 7 or Windows Vista, skip to Step 3.) 
echo.
echo Type the following command, and then press Enter.  It may take several minutes for the command operation to be completed.
echo DISM.exe /Online /Cleanup-image /Restorehealth
echo.
echo Important: When you run this command, DISM uses Windows Update to provide the files that are required to fix corruptions. However, if your Windows Update client is already broken, use a running Windows installation as the repair source, or use a Windows side-by-side folder from a network share or from a removable media, such as the Windows DVD, as the source of the files. To do this, run the following command instead:
echo DISM.exe /Online /Cleanup-Image /RestoreHealth /Source:C:\RepairSource\Windows /LimitAccess
echo.
echo Note: Replace the C:\RepairSource\Windows placeholder with the location of your repair source. For more information about using the DISM tool to repair Windows, reference Repair a Windows Image.
echo.
echo     At the command prompt, type the following command, and then press ENTER:
echo.
echo sfc /scannow
echo.
echo Command Prompt with administrator rights - sfc /scannow
echo.
echo. 
echo.
echo The sfc /scannow command will scan all protected system files, and replace corrupted files with a cached copy that is located in a compressed folder at %WinDir%\System32\dllcache.
echo The %WinDir% placeholder represents the Windows operating system folder. For example, C:\Windows.
echo.
echo Note Do not close this Command Prompt window until the verification is 100% complete. The scan results will be shown after this process is finished.
echo.
echo     After the process is finished, you may receive one of the following messages:
echo         Windows Resource Protection did not find any integrity violations.
echo.
echo.
echo         This means that you do not have any missing or corrupted system files.
echo         Windows Resource Protection could not perform the requested operation.
echo.
echo.
echo         To resolve this problem, perform the System File Checker scan in safe mode, and make sure that the PendingDeletes and PendingRenames folders exist under %WinDir%\WinSxS\Temp.
echo         Windows Resource Protection found corrupt files and successfully repaired them. Details are included in the CBS.Log %WinDir%\Logs\CBS\CBS.log.
echo.
echo.
echo         To view the detail information about the system file scan and restoration, go to How to view details of the System File Checker process.
echo         Windows Resource Protection found corrupt files but was unable to fix some of them. Details are included in the CBS.Log %WinDir%\Logs\CBS\CBS.log.
echo.
echo.
echo         To repair the corrupted files manually, view details of the System File Checker process to find the corrupted file, and then manually replace the corrupted file with a known good copy of the file.
echo.
echo More Information
echo How to view details of the System File Checker process
echo To view the details that included in the CBS.Log file, you can copy the information to the Sfcdetails.txt file by using the Findstr command, and then view the details in the Sfcdetails.txt. To do this, follow these steps:
echo.
echo     Open an elevated command prompt as described in the previous step 1.
echo     At the command prompt, type the following command, and then press ENTER:
echo.
echo     findstr /c:"[SR]" %windir%\Logs\CBS\CBS.log >"%userprofile%\Desktop\sfcdetails.txt" 
echo.
echo     Note The Sfcdetails.txt file contains details from every time that the System File Checker tool has been run on the computer. The file includes information about files that were not repaired by the System File Checker tool. Verify the date and time entries to determine the problem files that were found the last time that you ran the System File Checker tool.
echo     Open the Sfcdetails.txt file from your desktop.
echo     The Sfcdetails.txt file uses the following format:
echo     Date/Time SFC detail
echo     The following sample log file contains an entry for a file that could not be repaired:
echo.
echo     2007-01-12 12:10:42, Info                  CSI    00000008 [SR] Cannot 
echo     repair member file [l:34{17}]"Accessibility.dll" of Accessibility, Version = 
echo     6.0.6000.16386, pA = PROCESSOR_ARCHITECTURE_MSIL (8), Culture neutral, 
echo     VersionScope neutral, PublicKeyToken = {l:8 b:b03f5f7f11d50a3a}, Type 
echo     neutral, TypeName neutral, PublicKey neutral in the store, file is missing
echo.     
echo.
echo.
echo How to manually replace a corrupted system file with a known good copy of the file
echo.
echo After you determine which system file was corrupted and could not be repaired through the detail information in the Sfcdetails.txt file, find where the corrupted file located, and then manually replace the corrupted file with a known good copy of the file. To do this, follow these steps:
echo.
echo Note You may be able to get a known good copy of the system file from another computer that is running the same version of Windows with your computer. You may perform a System File Checker process on that computer to make sure the system file that you intend to copy is a good copy.
echo.
echo     Take administrative ownership of the corrupted system file. To do this, at an elevated command prompt, copy and then paste (or type) the following command, and then press ENTER:
echo     takeown /f Path_And_File_Name
echo     Note The Path_And_File_Name placeholder represents the path and the file name of the corrupted file. For example, type takeown /f C:\windows\system32\jscript.dll. 
echo     Command Prompt with administrator rights - command succeeded
echo.     
echo     Grant administrators full access to the corrupted system file. To do this, copy and paste (or type) the following command, and then press ENTER: icacls Path_And_File_Name /GRANT ADMINISTRATORS:F
echo     Note The Path_And_File_Name placeholder represents the path and the file name of the corrupted file. For example, type 
echo     icacls C:\windows\system32\jscript.dll /grant administrators:F.
echo     Command Prompt with administrator rights
echo.     
echo     Replace the corrupted system file with a known good copy of the file. To do this, copy and paste (or type) the following command, and then press ENTER:
echo     Copy Source_File Destination
echo     Note The Source_File placeholder represents the path and file name of the known good copy of the file on your computer, and the Destination placeholder represents the path and file name of the corrupted file. For example, type copy E:\temp\jscript.dll C:\windows\system32\jscript.dll.
echo.
echo If the steps above don't work, you may need to reinstall Windows. For more info, see Windows 10 recovery options.
echo Last Updated: 8 Jul 2019
pause
goto :eof